## cp2k 2.1.637

=== makefiles/Makefile ===
#
# make -j 16 sopt popt ssmp psmp
#
# will now perform a parallel build of 4 cp2k executables
#
.SUFFIXES: .F .dep .o .f90 .cu .c
SHELL = /bin/sh
#
# the home dir is taken from the current directory: you must cd to the makefiles
# directory before executing make.
# adding a symbolic link from the src directory to the Makefile in makefiles/ 
# also works fine
#
CP2KHOME  := $(PWD)/..
ARCH      := $(shell $(CP2KHOME)/tools/get_arch_code)
LIB1      = cp2k_base_lib
LIB2      = cp2k_fft_lib
LIB3      = dbcsr
LIBCP2K   = cp2k_lib
export VERSION=sopt
export WHAT   =_progr

### Dependent variables ###

ARCHDIR      = $(CP2KHOME)/arch
DOCDIR       = $(CP2KHOME)/doc
MAINEXEDIR   = $(CP2KHOME)/exe
MAINLIBDIR   = $(CP2KHOME)/lib
MAINOBJDIR   = $(CP2KHOME)/obj
PRETTYOBJDIR = $(CP2KHOME)/obj/prettified
TOOLDIR      = $(OBJDIR)/tools
TOOLSRC      = $(CP2KHOME)/tools
SRCDIR       = $(CP2KHOME)/src
SRCDIRS      = $(SRCDIR):$(SRCDIR)/lib:$(TOOLSRC)/metadyn:$(CP2KHOME)/cuda_tools
MAKEFILE     = $(CP2KHOME)/makefiles/Makefile
MACHINEDEFS  = $(ARCHDIR)/$(ARCH).$(VERSION)
PROG         = $(EXEDIR)/cp2k.$(VERSION)
CP2KSHELL    = $(EXEDIR)/cp2k_shell.$(VERSION)
FES          = $(EXEDIR)/fes.$(VERSION)
EXEDIR       = $(MAINEXEDIR)/$(ARCH)
LIBDIR       = $(MAINLIBDIR)/$(ARCH)
OBJDIR       = $(MAINOBJDIR)/$(ARCH)
OBJECTDEFS   = $(SRCDIR)/OBJECTDEFS
LIBOBJECTDEFS= $(SRCDIR)/lib/OBJECTDEFS
LIBNVOBJECTDEFS= $(CP2KHOME)/cuda_tools/NVOBJECTDEFS
LIB1_ARCHIVE = $(LIBDIR)/$(VERSION)/lib$(LIB1).a
LIB2_ARCHIVE = $(LIBDIR)/$(VERSION)/lib$(LIB2).a
LIB3_ARCHIVE = $(LIBDIR)/$(VERSION)/lib$(LIB3).a
LIB_CP2K_ARCHIVE  = $(LIBDIR)/$(VERSION)/lib$(LIBCP2K).a
SRCENTRY     = $(wildcard $(SRCDIR)/CVS/Entr*)
FESOBJECTDEFS  = $(TOOLSRC)/metadyn/OBJECTDEFS
DOXYGENDIR   = $(DOCDIR)/doxygen

### Definition of the multiple targets ###
#
VERSION_TARGETS = sopt sdbg popt pdbg ssmp psmp
#
# uses an ugly trick, these are disguised as file names, the directory (@D) part 
# is used as a version, the file (@F) part is used as the target.
#
LIB_TARGETS = $(addsuffix /lib ,$(VERSION_TARGETS)) 
ALL_TARGETS = $(addsuffix /all ,$(VERSION_TARGETS))
CLEAN_TARGETS = $(addsuffix /clean ,$(VERSION_TARGETS)) $(addsuffix /realclean ,$(VERSION_TARGETS))

#
# lists the targets that are not files
#
.PHONY : _all libs _progr _lib build clean realclean distclean $(CLEAN_TARGETS)\
         $(ALL_TARGETS) $(LIB_TARGETS) $(VERSION_TARGETS) fes dirs deptool

### Master rules ###
build: dirs deptool
	$(MAKE) -C $(SRCDIR) -f $(MAKEFILE) all.dep
	$(MAKE) -C $(SRCDIR)/lib -f $(MAKEFILE) lib.dep
	$(MAKE) -C $(OBJDIR)/$(VERSION) -f $(MAKEFILE) $(WHAT)

fes: dirs deptool
	$(MAKE) -C $(TOOLSRC)/metadyn/  -f $(MAKEFILE) fes.dep
	$(MAKE) -C $(OBJDIR)/$(VERSION) -f $(MAKEFILE) VERSION=$(VERSION) $(FES) 

dirs:
	@mkdir -p $(EXEDIR)
	@mkdir -p $(LIBDIR)/$(VERSION)
	@mkdir -p $(TOOLDIR)
	@mkdir -p $(OBJDIR)/$(VERSION)
	@mkdir -p $(PRETTYOBJDIR)

realpretty: prettyclean pretty

pretty: dirs
	$(MAKE) -C $(SRCDIR) -f $(MAKEFILE) _pretty
	$(MAKE) -C $(SRCDIR)/lib -f $(MAKEFILE) _pretty_lib3

deptool: dirs
	$(MAKE) -C $(TOOLDIR) -f $(MAKEFILE) makedepf90

libs:
	$(MAKE) -f $(MAKEFILE) VERSION=$(VERSION) WHAT=_lib build
all:
	$(MAKE) -f $(MAKEFILE) VERSION=$(VERSION) WHAT=_all build
progr:
	$(MAKE) -f $(MAKEFILE) VERSION=$(VERSION) WHAT=_progr build
cpshell:
	$(MAKE) -f $(MAKEFILE) VERSION=$(VERSION) WHAT=_cpshell build

#
# on a parallel build only one task should go a build the deptool
#
$(VERSION_TARGETS): dirs deptool
	$(MAKE) -f $(MAKEFILE) VERSION=$@ build

$(CLEAN_TARGETS):
	$(MAKE) -f $(MAKEFILE) VERSION=$(@D) $(@F)

$(ALL_TARGETS) $(LIB_TARGETS):
	$(MAKE) -f $(MAKEFILE) VERSION=$(@D) WHAT=_$(@F) build
#
# here we try to include all the objects that might need considering
#

include $(OBJECTDEFS)
include $(LIBOBJECTDEFS)
include $(FESOBJECTDEFS)
include $(MACHINEDEFS)
include $(LIBNVOBJECTDEFS)

OBJECTS = $(OBJECTS_GENERIC) $(OBJECTS_ARCHITECTURE)
FESOBJS = $(FESOBJ) $(OBJECTS_ARCHITECTURE)

# Cuda specific instructions
ifneq ($(NVCC),)
  LIBNV_ARCHIVE= $(LIBDIR)/$(VERSION)/libcp2k_cuda.a
endif

# Define the whole bunch of libraries needed
ALL_LIB =  $(LIB_CP2K_ARCHIVE) $(LIB3_ARCHIVE) $(LIB2_ARCHIVE) $(LIB1_ARCHIVE) $(LIBNV_ARCHIVE)

#
# some practical variables for the build.
# note that the last cvs entry is not necessarily the most recent
#
ifeq ($(CPPSHELL),)
CPPSHELL := -D__COMPILE_ARCH="\"$(ARCH)\""\
            -D__COMPILE_DATE="\"$(shell date)\""\
            -D__COMPILE_HOST="\"$(shell hostname)\""\
            -D__COMPILE_LASTCVS="\"$(shell tail -n1 $(SRCDIR)/CVS/Entries)\""
endif

ifneq ($(CPP),)
#
# always add the SRCDIR to the include path (-I here might not be portable) 
#
CPPFLAGS += $(CPPSHELL) -I$(SRCDIR)
else
FCFLAGS += $(CPPSHELL)
endif


### Slave rules ###
vpath %.F $(SRCDIRS)
vpath %.h $(SRCDIRS)
vpath %.f90 $(SRCDIRS)
vpath %.dep $(OBJDIR)/$(VERSION)
vpath %.pretty $(PRETTYOBJDIR)
vpath %.cu $(SRCDIRS)

#
# if the modules generated are not of the lower case form (e.g. kinds.F does not lead to kinds.mod)
# use MODDEPS = no in the arch file
# MODDEPS = upper does not work because of the rule '%.mod: %.o' is incorrect (see there), but if that is
# fixed, upper should work as well.
#
ifeq ($(MODDEPS),no)
MODSTRING=
else
ifeq ($(MODDEPS),upper)
MODSTRING=-m "%M.mod"
else
MODSTRING=-m "%m.mod"
endif
endif

#
# generation of the dependencies
#
# if HACKDEP=="yes" we hack the dependencies so that only modified source files are recompiled
# this is obviously not correct (i.e. can lead to a miscompiled CP2K), 
# but if you know what you are doing (i.e. you are sure that only information private to this module will be changed) might be useful nevertheless.
#
all.dep: $(OBJECTS:.o=.F) cp_common_uses.h cp2k.F cp2k_shell.F
ifeq ($(HACKDEP),yes)
	echo $^ | awk '{for (i=1;i<=NF;i++) {obj=$$(i) ; sub(".F",".o",obj); if ($$(i)!=obj) print obj,":",$$(i) }}' > $(OBJDIR)/$(VERSION)/all.dep
else
	$(TOOLDIR)/makedepf90 $(MODSTRING)  -free $^ > $(OBJDIR)/$(VERSION)/all.dep || ( rm -f $(OBJDIR)/$(VERSION)/all.dep  ; exit 1 )
endif

lib.dep: $(LIB1_OBJECTS:.o=.F) $(LIB2_OBJECTS:.o=.F)  $(LIB3_OBJECTS:.o=.F)
	$(TOOLDIR)/makedepf90 $(MODSTRING)  -free $^ > $(OBJDIR)/$(VERSION)/lib.dep || ( rm -f $(OBJDIR)/$(VERSION)/lib.dep ; exit 1 )

# this is kind of a hack, fes depends on files in other directories, hence the -I and the -b.
fes.dep: $(FESOBJS:.o=.F) 
	$(TOOLDIR)/makedepf90 -I$(SRCDIR) -b. $(MODSTRING)  -free $^ > $(OBJDIR)/$(VERSION)/fes.dep || ( rm -f $(OBJDIR)/$(VERSION)/fes.dep  ; exit 1 )

#
# and the rules doing the actual work
#
_all: $(ALL_LIB) $(PROG) fes $(CP2KSHELL)
_progr: $(PROG)
_lib: $(ALL_LIB)
_cpshell: $(CP2KSHELL)

_pretty:$(OBJECTS:.o=.pretty)
_pretty_lib3:$(LIB3_OBJECTS:.o=.pretty)

$(LIB1_ARCHIVE): $(LIB1_OBJECTS)
	$(AR) $(LIB1_ARCHIVE) $?
ifneq ($(RANLIB),)
	$(RANLIB) $(LIB1_ARCHIVE)
endif

$(LIB2_ARCHIVE): $(LIB2_OBJECTS)
	$(AR) $(LIB2_ARCHIVE) $?
ifneq ($(RANLIB),)
	$(RANLIB) $(LIB2_ARCHIVE)
endif

$(LIB3_ARCHIVE): $(LIB3_OBJECTS)
	$(AR) $(LIB3_ARCHIVE) $?
ifneq ($(RANLIB),)
	$(RANLIB) $(LIB3_ARCHIVE)
endif

#
# a hack to first compile the src/lib/ stuff before files from src/
# otherwise we have missing dependencies
#
ifneq ($(HACKLIBDEP),yes)
LIB_OBJECTS = $(LIB3_ARCHIVE) $(LIB2_ARCHIVE) $(LIB1_ARCHIVE)
else
LIB_OBJECTS =
endif

$(OBJECTS): $(LIB_OBJECTS)


$(LIB_CP2K_ARCHIVE): $(OBJECTS)
	$(AR) $(LIB_CP2K_ARCHIVE) $?
ifneq ($(RANLIB),)
	$(RANLIB) $(LIB_CP2K_ARCHIVE)
endif

ifneq ($(NVCC),)
  $(LIBNV_ARCHIVE): $(LIBNV_OBJECTS)
	$(AR) $(LIBNV_ARCHIVE) $?
endif

$(PROG): $(ALL_LIB) cp2k.o
	$(LD) $(LDFLAGS) -o $(PROG) cp2k.o $(ALL_LIB) $(LIBS)

$(CP2KSHELL): $(ALL_LIB) cp2k_shell.o
	$(LD) $(LDFLAGS) -o $(CP2KSHELL) cp2k_shell.o $(ALL_LIB) $(LIBS)

#
# these are tools, but their integration in the build is ugly at least (e.g. see dependencies).
#
makedepf90:
	-test -d $(TOOLDIR)/makedepf90-build || cp -r $(TOOLSRC)/makedepf90 makedepf90-build
	{ cd makedepf90-build ; ./configure --prefix=$(TOOLDIR) --bindir=$(TOOLDIR) ; $(MAKE) VERSION="2.8.8cp2k" ; $(MAKE) install ; }

$(FES): $(FESOBJS)
	$(LD) $(LDFLAGS) -o $(FES) $(FESOBJS)


#
# the rule how to generate the .o from the .F
# only if CPP is different from null we do a step over the C preprocessor (which is slower)
# in the other case the fortran compiler takes care of this directly
#
%.o: %.F
ifneq ($(CPP),)
	$(CPP) $(CPPFLAGS) $< > $*.f90
	$(FC) -c $(FCFLAGS) $*.f90
else
	$(FC) -c $(FCFLAGS) $<
endif

%.pretty: %.F 
	$(TOOLSRC)/prettify.py $<
	@touch $(PRETTYOBJDIR)/$*.pretty

%.o: %.cu
	$(NVCC) -c $(NVFLAGS) $<

#
# here we cheat... this tells make that .mod can be generated from .o (this holds in CP2K)
# by doing nothing
# it avoids recompilation if .o is more recent than .F, but .mod is older than .F
# (because it didn't change, as e.g. g95 can do)
#
# this is problematic if the module names are uppercase e.g. KINDS.mod (because this rule expands to kinds.mod)
#
%.mod: %.o
	@true

#
# clean prettified files
#
prettyclean:
	-rm -rf $(PRETTYOBJDIR)

#
# delete the intermediate files, but not the libraries and executables. 
# Most useful to save space on the disk
#
clean:
	-test ! -d $(OBJDIR)/$(VERSION) || { cd $(OBJDIR)/$(VERSION) ; rm -f *.mod ; }
	-test ! -d $(OBJDIR)/$(VERSION) || { cd $(OBJDIR)/$(VERSION) ; rm -f *.o ; } 
	-test ! -d $(OBJDIR)/$(VERSION) || { cd $(OBJDIR)/$(VERSION) ; rm -f *.f90 ; }
	-test ! -d $(OBJDIR)/$(VERSION) || { cd $(OBJDIR)/$(VERSION) ; rm -f *.dep ; }

#
# delete the intermediate files, the programs and libraries and anything that might be in the objdir directory
# Use this if you want to rebuild the executable (for a given compiler and or VERSION)
#
realclean: clean
	-test ! -d $(OBJDIR)/$(VERSION) || { cd $(OBJDIR)/$(VERSION) ; rm -f * ; }
	-rm -f $(PROG)
	-rm -f $(LIB1_ARCHIVE)
	-rm -f $(LIB2_ARCHIVE)
	-rm -f $(LIB3_ARCHIVE)
	-rm -f $(LIB_CP2K_ARCHIVE)
#
# really remove all build files not in CVS
#
distclean:
	rm -rf $(DOXYGENDIR) $(MAINEXEDIR) $(MAINLIBDIR) $(MAINOBJDIR)

#
# so far CP2K does not install, but give a hint to the user
#
install:
	@echo ""
	@echo "The CP2K executable is $(PROG)"
	@echo ""
#
doxygen/clean:
	-rm -rf $(DOXYGENDIR)
#
# Automatic source code documentation using Doxygen
# Prerequisites:
# - stable doxygen release 1.5.4 (Oct. 27, 2007)
# - graphviz (2.16.1)
# - webdot (2.16)
#
doxygen: doxygen/clean
	@mkdir -p $(DOXYGENDIR)
	{ cd $(SRCDIR) ; cp *.f90 *.h $(DOXYGENDIR) ; for f in $(OBJECTS:.o=) ; do cp $${f}.F $(DOXYGENDIR)/$${f}.f90; done ; }
	{ cd $(SRCDIR)/lib ; for f in $(LIB1_OBJECTS:.o=) $(LIB2_OBJECTS:.o=) $(LIB3_OBJECTS:.o=) ; do cp $${f}.F $(DOXYGENDIR)/$${f}.f90; done ; }
	{ cd $(DOXYGENDIR) ; doxygen $(DOCDIR)/Doxyfile ; }
# 
# an additional dependency of the CVS entries in the source directory
# to recpp cp2k_info.F whenever the CVS/Entries file is updated (and exists)
#
ifneq ($(strip $(SRCENTRY)),)
cp2k_info.o:$(SRCENTRY)
endif

#
# Load the automatically generated rules of makedepf90 
#
ifneq ($(strip $(wildcard *.dep)),)
include $(wildcard *.dep)
endif

=== debian/changelog ===
cp2k (2.1.637-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * Build-Depend on flex and bison, to fix FTBFS (Closes: #641242)

 -- Aron Xu <aron@debian.org>  Fri, 20 Jan 2012 19:59:16 +0800

cp2k (2.1.637-2) unstable; urgency=low

  * debian/copyright: Clarify that recurse.f90 is under a BSDish license
  * debian/rules (clean): Run dh_clean as well.
  * debian/rules: Rename clean target to override_dh_auto_clean and remove
    dh_clean from it again.
  * debian/rules: Rename build target to override_dh_auto_build.

 -- Michael Banck <mbanck@debian.org>  Sun, 11 Sep 2011 17:21:15 +0200

cp2k (2.1.637-1) unstable; urgency=low

  * Initial upload (Closes: #518984).

 -- Michael Banck <mbanck@debian.org>  Thu, 08 Sep 2011 17:50:44 +0200

=== debian/control ===
Source: cp2k
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: debhelper (>= 7.0.50~), gfortran, libblas-dev, liblapack-dev, libfftw3-dev, libscalapack-mpi-dev, mpi-default-dev, flex, bison
Standards-Version: 3.9.2
Homepage: http://cp2k.berlios.de/
Vcs-Browser: http://svn.debian.org/wsvn/debichem/unstable/openbabel/
Vcs-Svn: svn://svn.debian.org/svn/debichem/unstable/openbabel/
DM-Upload-Allowed: yes

Package: cp2k
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Ab Initio Molecular Dynamics
 CP2K is a program to perform atomistic and molecular simulations of solid
 state, liquid, molecular and biological systems.  It provides a general
 framework for different methods such as e.g. density functional theory (DFT)
 using a mixed Gaussian and plane waves approach (GPW), and classical pair and
 many-body potentials. It provides state-of-the-art methods for efficient and
 accurate atomistic simulations.
 .
 CP2K includes Quickstep for fast and accurate density functional calculations
 using a mixed Gaussian and plane waves approach.  This makes it possible to
 perform accurate and efficient DFT calculations on large, complex systems such
 as e.g. liquids, crystals, proteins and interfaces.   Both static property
 calculations (such as spectra computed with TDDFT or as derivative properties
 of the total energy) and dynamical properties (e.g. diffusion, based on
 molecular dynamics) are possible.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

PLATFORM=`uname`
ARCH=`uname -m`
FORT_C_NAME=gfortran

%:
	dh $@ 

override_dh_auto_clean:
	(cd makefiles; $(MAKE) distclean)
	rm -f arch/$(PLATFORM)-$(ARCH)-$(FORT_C_NAME).*
	dh_auto_clean

override_dh_auto_build:
	(cd arch; ln -fs $(PLATFORM)-generic-$(FORT_C_NAME).popt $(PLATFORM)-$(ARCH)-$(FORT_C_NAME).popt)
	(cd makefiles; $(MAKE) ARCH=$(PLATFORM)-$(ARCH)-$(FORT_C_NAME) VERSION=popt all)

override_dh_auto_test:
	-(cd tools; ./do_regtest -quick -config ../debian/regtest.config)

## cp2k 2.2.426

=== makefiles/Makefile ===
--- 
+++ 
@@ -15,7 +15,8 @@
 ARCH      := $(shell $(CP2KHOME)/tools/get_arch_code)
 LIB1      = cp2k_base_lib
 LIB2      = cp2k_fft_lib
-LIB3      = dbcsr
+LIB3      = cp2k_dbcsr_lib
+LIB4      = cp2k_ma_lib
 LIBCP2K   = cp2k_lib
 export VERSION=sopt
 export WHAT   =_progr
@@ -31,7 +32,7 @@
 TOOLDIR      = $(OBJDIR)/tools
 TOOLSRC      = $(CP2KHOME)/tools
 SRCDIR       = $(CP2KHOME)/src
-SRCDIRS      = $(SRCDIR):$(SRCDIR)/lib:$(TOOLSRC)/metadyn:$(CP2KHOME)/cuda_tools
+SRCDIRS      = $(SRCDIR):$(SRCDIR)/lib:$(SRCDIR)/arch_lib:$(SRCDIR)/dbcsr_lib:$(SRCDIR)/fft_lib:$(TOOLSRC)/metadyn:$(CP2KHOME)/cuda_tools:$(CP2KHOME)/machine
 MAKEFILE     = $(CP2KHOME)/makefiles/Makefile
 MACHINEDEFS  = $(ARCHDIR)/$(ARCH).$(VERSION)
 PROG         = $(EXEDIR)/cp2k.$(VERSION)
@@ -41,11 +42,16 @@
 LIBDIR       = $(MAINLIBDIR)/$(ARCH)
 OBJDIR       = $(MAINOBJDIR)/$(ARCH)
 OBJECTDEFS   = $(SRCDIR)/OBJECTDEFS
-LIBOBJECTDEFS= $(SRCDIR)/lib/OBJECTDEFS
+LIB1_OBJECTDEFS= $(SRCDIR)/lib/OBJECTDEFS
+LIB2_OBJECTDEFS= $(SRCDIR)/dbcsr_lib/OBJECTDEFS
+LIB3_OBJECTDEFS= $(SRCDIR)/fft_lib/OBJECTDEFS
+LIB4_OBJECTDEFS= $(SRCDIR)/arch_lib/OBJECTDEFS
 LIBNVOBJECTDEFS= $(CP2KHOME)/cuda_tools/NVOBJECTDEFS
+LIBMA_OBJECTDEFS = $(CP2KHOME)/machine/LIBMA_OBJECTDEFS
 LIB1_ARCHIVE = $(LIBDIR)/$(VERSION)/lib$(LIB1).a
 LIB2_ARCHIVE = $(LIBDIR)/$(VERSION)/lib$(LIB2).a
 LIB3_ARCHIVE = $(LIBDIR)/$(VERSION)/lib$(LIB3).a
+LIB4_ARCHIVE = $(LIBDIR)/$(VERSION)/lib$(LIB4).a
 LIB_CP2K_ARCHIVE  = $(LIBDIR)/$(VERSION)/lib$(LIBCP2K).a
 SRCENTRY     = $(wildcard $(SRCDIR)/CVS/Entr*)
 FESOBJECTDEFS  = $(TOOLSRC)/metadyn/OBJECTDEFS
@@ -53,7 +59,9 @@
 
 ### Definition of the multiple targets ###
 #
-VERSION_TARGETS = sopt sdbg popt pdbg ssmp psmp
+# Should really be
+#VERSION_TARGTES= sopt sdbg popt pdbg topt hopt tdbg hdbg
+VERSION_TARGETS = sopt sdbg popt pdbg ssmp psmp tdbg hdbg
 #
 # uses an ugly trick, these are disguised as file names, the directory (@D) part 
 # is used as a version, the file (@F) part is used as the target.
@@ -70,13 +78,16 @@
 
 ### Master rules ###
 build: dirs deptool
-	$(MAKE) -C $(SRCDIR) -f $(MAKEFILE) all.dep
-	$(MAKE) -C $(SRCDIR)/lib -f $(MAKEFILE) lib.dep
-	$(MAKE) -C $(OBJDIR)/$(VERSION) -f $(MAKEFILE) $(WHAT)
+	+$(MAKE) -C $(SRCDIR) -f $(MAKEFILE) all.dep
+	+$(MAKE) -C $(SRCDIR)/lib -f $(MAKEFILE) lib.dep
+	+$(MAKE) -C $(SRCDIR)/dbcsr_lib -f $(MAKEFILE) dbcsr.dep
+	+$(MAKE) -C $(SRCDIR)/fft_lib -f $(MAKEFILE) fft.dep
+	+$(MAKE) -C $(SRCDIR)/arch_lib -f $(MAKEFILE) ma.dep
+	+$(MAKE) -C $(OBJDIR)/$(VERSION) -f $(MAKEFILE) $(WHAT)
 
 fes: dirs deptool
-	$(MAKE) -C $(TOOLSRC)/metadyn/  -f $(MAKEFILE) fes.dep
-	$(MAKE) -C $(OBJDIR)/$(VERSION) -f $(MAKEFILE) VERSION=$(VERSION) $(FES) 
+	+$(MAKE) -C $(TOOLSRC)/metadyn/  -f $(MAKEFILE) fes.dep
+	+$(MAKE) -C $(OBJDIR)/$(VERSION) -f $(MAKEFILE) HACKLIBDEP=yes VERSION=$(VERSION) $(FES) 
 
 dirs:
 	@mkdir -p $(EXEDIR)
@@ -88,41 +99,48 @@
 realpretty: prettyclean pretty
 
 pretty: dirs
-	$(MAKE) -C $(SRCDIR) -f $(MAKEFILE) _pretty
-	$(MAKE) -C $(SRCDIR)/lib -f $(MAKEFILE) _pretty_lib3
+	+$(MAKE) -C $(SRCDIR) -f $(MAKEFILE) _pretty
+	+$(MAKE) -C $(SRCDIR)/lib       -f $(MAKEFILE) _pretty_lib1
+	+$(MAKE) -C $(SRCDIR)/fft_lib   -f $(MAKEFILE) _pretty_lib2
+	+$(MAKE) -C $(SRCDIR)/dbcsr_lib -f $(MAKEFILE) _pretty_lib3
+	+$(MAKE) -C $(SRCDIR)/arch_lib  -f $(MAKEFILE) _pretty_lib4
 
 deptool: dirs
-	$(MAKE) -C $(TOOLDIR) -f $(MAKEFILE) makedepf90
+	+$(MAKE) LDFLAGS=$(MAKDEPF90_LDFLAGS) -C $(TOOLDIR) -f $(MAKEFILE) makedepf90
 
 libs:
-	$(MAKE) -f $(MAKEFILE) VERSION=$(VERSION) WHAT=_lib build
+	+$(MAKE) -f $(MAKEFILE) VERSION=$(VERSION) WHAT=_lib build
 all:
-	$(MAKE) -f $(MAKEFILE) VERSION=$(VERSION) WHAT=_all build
+	+$(MAKE) -f $(MAKEFILE) VERSION=$(VERSION) WHAT=_all build
 progr:
-	$(MAKE) -f $(MAKEFILE) VERSION=$(VERSION) WHAT=_progr build
+	+$(MAKE) -f $(MAKEFILE) VERSION=$(VERSION) WHAT=_progr build
 cpshell:
-	$(MAKE) -f $(MAKEFILE) VERSION=$(VERSION) WHAT=_cpshell build
+	+$(MAKE) -f $(MAKEFILE) VERSION=$(VERSION) WHAT=_cpshell build
 
 #
 # on a parallel build only one task should go a build the deptool
 #
 $(VERSION_TARGETS): dirs deptool
-	$(MAKE) -f $(MAKEFILE) VERSION=$@ build
+	+$(MAKE) -f $(MAKEFILE) VERSION=$@ build
 
 $(CLEAN_TARGETS):
-	$(MAKE) -f $(MAKEFILE) VERSION=$(@D) $(@F)
+	+$(MAKE) -f $(MAKEFILE) VERSION=$(@D) $(@F)
 
 $(ALL_TARGETS) $(LIB_TARGETS):
-	$(MAKE) -f $(MAKEFILE) VERSION=$(@D) WHAT=_$(@F) build
+	+$(MAKE) -f $(MAKEFILE) VERSION=$(@D) WHAT=_$(@F) build
+
 #
 # here we try to include all the objects that might need considering
 #
-
 include $(OBJECTDEFS)
-include $(LIBOBJECTDEFS)
+include $(LIB1_OBJECTDEFS)
+include $(LIB2_OBJECTDEFS)
+include $(LIB3_OBJECTDEFS)
+include $(LIB4_OBJECTDEFS)
 include $(FESOBJECTDEFS)
 include $(MACHINEDEFS)
 include $(LIBNVOBJECTDEFS)
+include $(LIBMA_OBJECTDEFS)
 
 OBJECTS = $(OBJECTS_GENERIC) $(OBJECTS_ARCHITECTURE)
 FESOBJS = $(FESOBJ) $(OBJECTS_ARCHITECTURE)
@@ -132,8 +150,14 @@
   LIBNV_ARCHIVE= $(LIBDIR)/$(VERSION)/libcp2k_cuda.a
 endif
 
+# HWLOC
+ifneq ($(HWLOC),)
+  LIBMA_ARCHIVE= $(LIBDIR)/$(VERSION)/libcp2k_ma.a
+endif
+
+
 # Define the whole bunch of libraries needed
-ALL_LIB =  $(LIB_CP2K_ARCHIVE) $(LIB3_ARCHIVE) $(LIB2_ARCHIVE) $(LIB1_ARCHIVE) $(LIBNV_ARCHIVE)
+ALL_LIB =  $(LIB_CP2K_ARCHIVE) $(LIB3_ARCHIVE) $(LIB2_ARCHIVE) $(LIB1_ARCHIVE) $(LIB4_ARCHIVE) $(LIBMA_ARCHIVE) $(LIBNV_ARCHIVE) 
 
 #
 # some practical variables for the build.
@@ -163,6 +187,7 @@
 vpath %.dep $(OBJDIR)/$(VERSION)
 vpath %.pretty $(PRETTYOBJDIR)
 vpath %.cu $(SRCDIRS)
+vpath %.c $(SRCDIRS)
 
 #
 # if the modules generated are not of the lower case form (e.g. kinds.F does not lead to kinds.mod)
@@ -187,15 +212,24 @@
 # this is obviously not correct (i.e. can lead to a miscompiled CP2K), 
 # but if you know what you are doing (i.e. you are sure that only information private to this module will be changed) might be useful nevertheless.
 #
-all.dep: $(OBJECTS:.o=.F) cp_common_uses.h cp2k.F cp2k_shell.F
+all.dep: $(OBJECTS:.o=.F) $(LIB1_OBJECTS:.o=.F) $(LIB2_OBJECTS:.o=.F) $(LIB4_OBJECTS:.o=.F) $(LIB3_OBJECTS:.o=.F) cp_common_uses.h cp2k.F cp2k_shell.F
 ifeq ($(HACKDEP),yes)
 	echo $^ | awk '{for (i=1;i<=NF;i++) {obj=$$(i) ; sub(".F",".o",obj); if ($$(i)!=obj) print obj,":",$$(i) }}' > $(OBJDIR)/$(VERSION)/all.dep
 else
 	$(TOOLDIR)/makedepf90 $(MODSTRING)  -free $^ > $(OBJDIR)/$(VERSION)/all.dep || ( rm -f $(OBJDIR)/$(VERSION)/all.dep  ; exit 1 )
 endif
 
-lib.dep: $(LIB1_OBJECTS:.o=.F) $(LIB2_OBJECTS:.o=.F)  $(LIB3_OBJECTS:.o=.F)
+lib.dep: $(LIB1_OBJECTS:.o=.F)
 	$(TOOLDIR)/makedepf90 $(MODSTRING)  -free $^ > $(OBJDIR)/$(VERSION)/lib.dep || ( rm -f $(OBJDIR)/$(VERSION)/lib.dep ; exit 1 )
+
+fft.dep: $(LIB2_OBJECTS:.o=.F)
+	$(TOOLDIR)/makedepf90 $(MODSTRING)  -free $^ > $(OBJDIR)/$(VERSION)/fft.dep || ( rm -f $(OBJDIR)/$(VERSION)/fft.dep ; exit 1 )
+
+dbcsr.dep: $(LIB3_OBJECTS:.o=.F) $(LIB4_OBJECTS:.o=.F)
+	$(TOOLDIR)/makedepf90 $(MODSTRING)  -free $^ > $(OBJDIR)/$(VERSION)/dbcsr.dep || ( rm -f $(OBJDIR)/$(VERSION)/dbcsr.dep ; exit 1 )
+
+ma.dep: $(LIB4_OBJECTS:.o=.F)
+	$(TOOLDIR)/makedepf90 $(MODSTRING)  -free $^ > $(OBJDIR)/$(VERSION)/ma.dep || ( rm -f $(OBJDIR)/$(VERSION)/ma.dep ; exit 1 )
 
 # this is kind of a hack, fes depends on files in other directories, hence the -I and the -b.
 fes.dep: $(FESOBJS:.o=.F) 
@@ -210,7 +244,10 @@
 _cpshell: $(CP2KSHELL)
 
 _pretty:$(OBJECTS:.o=.pretty)
+_pretty_lib1:$(LIB1_OBJECTS:.o=.pretty)
+_pretty_lib2:$(LIB2_OBJECTS:.o=.pretty)
 _pretty_lib3:$(LIB3_OBJECTS:.o=.pretty)
+_pretty_lib4:$(LIB4_OBJECTS:.o=.pretty)
 
 $(LIB1_ARCHIVE): $(LIB1_OBJECTS)
 	$(AR) $(LIB1_ARCHIVE) $?
@@ -230,18 +267,22 @@
 	$(RANLIB) $(LIB3_ARCHIVE)
 endif
 
+$(LIB4_ARCHIVE): $(LIB4_OBJECTS)
+	$(AR) $(LIB4_ARCHIVE) $?
+ifneq ($(RANLIB),)
+	$(RANLIB) $(LIB4_ARCHIVE)
+endif
+
+
 #
 # a hack to first compile the src/lib/ stuff before files from src/
 # otherwise we have missing dependencies
 #
 ifneq ($(HACKLIBDEP),yes)
-LIB_OBJECTS = $(LIB3_ARCHIVE) $(LIB2_ARCHIVE) $(LIB1_ARCHIVE)
+LIB_OBJECTS = $(LIB4_ARCHIVE) $(LIB3_ARCHIVE) $(LIB2_ARCHIVE) $(LIB1_ARCHIVE)
 else
 LIB_OBJECTS =
 endif
-
-$(OBJECTS): $(LIB_OBJECTS)
-
 
 $(LIB_CP2K_ARCHIVE): $(OBJECTS)
 	$(AR) $(LIB_CP2K_ARCHIVE) $?
@@ -254,11 +295,20 @@
 	$(AR) $(LIBNV_ARCHIVE) $?
 endif
 
+ifneq ($(HWLOC),)
+  $(LIBMA_ARCHIVE): $(LIBMA_OBJECTS)
+	$(AR) $(LIBMA_ARCHIVE) $?
+endif
+
+
 $(PROG): $(ALL_LIB) cp2k.o
-	$(LD) $(LDFLAGS) -o $(PROG) cp2k.o $(ALL_LIB) $(LIBS)
+	+$(LD) $(LDFLAGS) -o $(PROG) cp2k.o $(ALL_LIB) $(LIBS)
 
 $(CP2KSHELL): $(ALL_LIB) cp2k_shell.o
-	$(LD) $(LDFLAGS) -o $(CP2KSHELL) cp2k_shell.o $(ALL_LIB) $(LIBS)
+	+$(LD) $(LDFLAGS) -o $(CP2KSHELL) cp2k_shell.o $(ALL_LIB) $(LIBS)
+
+$(FES): $(FESOBJS) graph.o 
+	+$(LD) $(LDFLAGS) -o $(FES) graph.o $(FESOBJS)
 
 #
 # these are tools, but their integration in the build is ugly at least (e.g. see dependencies).
@@ -266,10 +316,6 @@
 makedepf90:
 	-test -d $(TOOLDIR)/makedepf90-build || cp -r $(TOOLSRC)/makedepf90 makedepf90-build
 	{ cd makedepf90-build ; ./configure --prefix=$(TOOLDIR) --bindir=$(TOOLDIR) ; $(MAKE) VERSION="2.8.8cp2k" ; $(MAKE) install ; }
-
-$(FES): $(FESOBJS)
-	$(LD) $(LDFLAGS) -o $(FES) $(FESOBJS)
-
 
 #
 # the rule how to generate the .o from the .F
@@ -290,6 +336,10 @@
 
 %.o: %.cu
 	$(NVCC) -c $(NVFLAGS) $<
+
+%.o: %.c
+	echo $<
+	$(CC) -c $(CFLAGS) $<
 
 #
 # here we cheat... this tells make that .mod can be generated from .o (this holds in CP2K)
@@ -328,46 +378,9 @@
 	-rm -f $(LIB1_ARCHIVE)
 	-rm -f $(LIB2_ARCHIVE)
 	-rm -f $(LIB3_ARCHIVE)
+	-rm -f $(LIB4_ARCHIVE)
 	-rm -f $(LIB_CP2K_ARCHIVE)
 #
 # really remove all build files not in CVS
 #
 distclean:
-	rm -rf $(DOXYGENDIR) $(MAINEXEDIR) $(MAINLIBDIR) $(MAINOBJDIR)
-
-#
-# so far CP2K does not install, but give a hint to the user
-#
-install:
-	@echo ""
-	@echo "The CP2K executable is $(PROG)"
-	@echo ""
-#
-doxygen/clean:
-	-rm -rf $(DOXYGENDIR)
-#
-# Automatic source code documentation using Doxygen
-# Prerequisites:
-# - stable doxygen release 1.5.4 (Oct. 27, 2007)
-# - graphviz (2.16.1)
-# - webdot (2.16)
-#
-doxygen: doxygen/clean
-	@mkdir -p $(DOXYGENDIR)
-	{ cd $(SRCDIR) ; cp *.f90 *.h $(DOXYGENDIR) ; for f in $(OBJECTS:.o=) ; do cp $${f}.F $(DOXYGENDIR)/$${f}.f90; done ; }
-	{ cd $(SRCDIR)/lib ; for f in $(LIB1_OBJECTS:.o=) $(LIB2_OBJECTS:.o=) $(LIB3_OBJECTS:.o=) ; do cp $${f}.F $(DOXYGENDIR)/$${f}.f90; done ; }
-	{ cd $(DOXYGENDIR) ; doxygen $(DOCDIR)/Doxyfile ; }
-# 
-# an additional dependency of the CVS entries in the source directory
-# to recpp cp2k_info.F whenever the CVS/Entries file is updated (and exists)
-#
-ifneq ($(strip $(SRCENTRY)),)
-cp2k_info.o:$(SRCENTRY)
-endif
-
-#
-# Load the automatically generated rules of makedepf90 
-#
-ifneq ($(strip $(wildcard *.dep)),)
-include $(wildcard *.dep)
-endif

=== debian/changelog ===
cp2k (2.2.426-8) unstable; urgency=high

  * debian/patches/basis_set_error_631++Gxx.patch: New patch, fixes the
    parameters of the 6-31++G** basis set, which was missing the diffuse
    function, thus making it identical to the 6-31G*/6-31G** basis sets.
    Patch is taken from upstream revision 12850 (Closes: #705746).

 -- Michael Banck <mbanck@debian.org>  Fri, 19 Apr 2013 16:07:40 +0200

cp2k (2.2.426-7) unstable; urgency=low

  * debian/patches/dftb_atom_input_dependence.patch: Fix dependence on heavy
    atom sequence in DFTB calculations, taken from upstream revision 12753
    (Closes: #702801).

 -- Michael Banck <mbanck@debian.org>  Mon, 11 Mar 2013 18:34:14 +0100

cp2k (2.2.426-6) unstable; urgency=low

  * debian/rules (FFTW3_ALIGN): New variable, set to '-D__FFTW3_UNALIGNED' on
    i386.
  * debian/patches/makeflags.patch: Include $(FFTW3_ALIGN) environment
    variable in $(DFLAGS).
  * debian/patches/fftw3_unaligned.patch: New patch, unconditionally adds the
    FFTW_UNALIGNED flag to the FFTW3 plan if __FFTW3_UNALIGNED is defined,
    thanks to Julian Taylor (Closes: #686874).
  * debian/control (Description): Added Metadynamics to capabilities.

 -- Michael Banck <mbanck@debian.org>  Fri, 07 Sep 2012 00:27:39 +0200

cp2k (2.2.426-5) unstable; urgency=low

  [ Michael Banck ]
  * debian/control (Description): Overhauled.
  * debian/upstream: New file.
  * debian/cp2k-data.install: Added tests/QS/dftd3.dat for the DFT-D3 pair
    potentials and tests/QS/t_c_g.dat for the truncated gamma function
    parameters.
  * debian/cp2k-data.install: Added tests/QS/BASIS_ADMM for the
    density-fitting basis sets.

  [ Andreas Tille ]
  * debian/upstream: Enhanced citation information.

  [ Daniel Leidert ]
  * debian/watch: Added.

 -- Michael Banck <mbanck@debian.org>  Mon, 03 Sep 2012 19:18:00 +0200

cp2k (2.2.426-4) unstable; urgency=low

  * debian/rules (override_dh_auto_test): Reactivate test suite again.  Link
    to the testresults orig-tarball compontent for comparison and run some
    representative regression test suite directories.
  * debian/rules (override_dh_auto_test): Only run testsuite if
    DEB_BUILD_OPTIONS does not contain `nocheck', as per policy.
  * debian/README.source: New file.
  * debian/rules (override_dh_auto_build, override_dh_auto_clean): Build html
    input file documentation from xml output and remove html and xml files on
    clean.
  * debian/control (Build-Depends): Added libsaxonb-java and
    default-jre-headless.
  * debian/cp2k.install: Install generated input file documentation rather
    than the rest of the documentation.
  * debian/rules (OMPI_MCA_plm_rsh_agent): New variable, makes built
    executable run successfully in a chroot.
  * debian/patches/testsuite_output.patch: New patch, echoes the name of each
    test in order to produce some output and avoid timeouts.

 -- Michael Banck <mbanck@debian.org>  Sat, 24 Mar 2012 18:04:41 +0100

cp2k (2.2.426-3) unstable; urgency=low

  * debian/patches/makeflags.patch: Use -lmpif90 -lmpif77 which also work with
    mpich, instead of the -lmpi_f90 -lmpi_f77 variants.
  * debian/rules (PLATFORM): Hardcode to Linux for now.

 -- Michael Banck <mbanck@debian.org>  Sun, 19 Feb 2012 14:15:17 +0100

cp2k (2.2.426-2) unstable; urgency=low

  * debian/patches/makeflags.patch: Updated, so that $(CPPFLAGS) includes
    $(DLFAGS), making the fftw3 library getting actually used.
  * debian/control (Build-Depends): Added libint-dev.
  * debian/patches/makeflags.patch: Updated for libint.
  * debian/cp2k.examples: Added He-ri.inp as an examples using libint.
  * debian/patches/makeflags.patch: Added to -ffree-line-length-none to
    $(FCFLAGS), thanks to Aaron M. Ucko (Closes: #660176). 
  * debian/rules: include /usr/share/mpi-default-dev/debian_defaults.
  * debian/rules (LIB_SCALAPACK): New variable, exporting the the scalapack
    library according to $(ARCH_DEFAULT_MPI_IMPL).
  * debian/patches/makeflags.patch: Added $(LIB_SCALAPACK) to parallel $(LIBS)
    variable.
  * debian/rules (LIB_BLACS): New variable, exporting the the blacs library
    according to $(ARCH_DEFAULT_MPI_IMPL).
  * debian/patches/makeflags.patch: Added $(LIB_BLACS) to parallel $(LIBS)
    variable.

 -- Michael Banck <mbanck@debian.org>  Sat, 18 Feb 2012 18:52:05 +0100

cp2k (2.2.426-1) unstable; urgency=low

  * New upstream release.
  * debian/patches/fortran_continuing_lines.patch: Refreshed.
  * Acknowledge NMU.
  * debian/control (Homepage): Updated.
  * debian/control (Vcs-Browser, Vcs-Svn): Fixed.
  * debian/copyright: Updated download location. 
  * debian/patches/reset_cppflags_makdepf90.patch: Refreshed.
  * debian/patches/makeflags.patch: Removed -march=native from FCFLAGS.
  * debian/rules (override_dh_auto_clean): Generate platform-specific symlink
    for distclean as well (Closes: #641242).
  * debian/rules (override_dh_auto_test): Disable test suite for now, as no
    output verification is done.
  * debian/docs: Renamed to ...
  * debian/cp2k.docs: ... this.
  * debian/install: Renamed to ...
  * debian/cp2k.install: ... this.
  * debian/control (cp2k-data): New package, containing the basis sets,
    pseudopotentials and force-field parameters.
  * debian/cp2k-data.install: New file.
  * debian/cp2k-data.dirs: New file.
  * debian/cp2k.links: New file.
  * debian/patches/data_files_standard_location.patch: New patch, adds support
    for looking up data files in /usr/share/cp2k if they are not found in the
    location specified in the input file.
  * debian/rules (override_dh_auto_clean): Remove regression test outputs as
    well.
  * debian/cp2k-data.links: New file, linking GTH_POTENTIALS to the default
    POTENTIAL file name.
  * debian/cp2k.examples: New file.

 -- Michael Banck <mbanck@debian.org>  Mon, 13 Feb 2012 16:12:29 +0100

=== debian/control ===
Source: cp2k
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: debhelper (>= 7.0.50~), gfortran, libblas-dev, liblapack-dev, libfftw3-dev, libint-dev, libscalapack-mpi-dev, mpi-default-dev, flex, bison, libsaxonb-java, default-jre-headless
Standards-Version: 3.9.2
Homepage: http://www.cp2k.org
Vcs-Browser: http://svn.debian.org/wsvn/debichem/unstable/cp2k/
Vcs-Svn: svn://svn.debian.org/svn/debichem/unstable/cp2k/
DM-Upload-Allowed: yes

Package: cp2k
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, cp2k-data (= ${source:Version})
Description: Ab Initio Molecular Dynamics
 CP2K is a program to perform simulations of solid state, liquid, molecular and
 biological systems. It is especially aimed at massively parallel and linear
 scaling electronic structure methods and state-of-the-art ab-inito molecular
 dynamics (AIMD) simulations. Features include:
 .
 Ab-initio Electronic Structure Theory Methods using the QUICKSTEP module:
 .
  * Density-Functional Theory (DFT) Calculations with various Exchange-
    Correlation (XC) functionals
  * Hartree-Fock (HF) Calculations
  * Gas phase or Periodic boundary conditions (PBC)
  * Basis sets include various standard Gaussian-Type Orbitals (GTOs), Pseudo-
    potential plane-waves (PW), augmented plane waves (APW) and a mixed
    Gaussian and (augmented) plane wave approach (GPW / GAPW)
  * Pseudo-Potentials (PP) including the norm-conserving, seperable
    Goedecker-Teter-Hutter (GTH) PP
  * Local Density Approximation (LDA) XC functionals including SVWN3, SVWN5,
    PW92 and PADE
  * Gradient-corrected (GGA) XC functionals including BLYP, BP86, PW91, PBE and
    HCTH120 as well as the meta-GGA XC functional TPSS
  * Hybrid XC functionals with exact Hartree-Fock Exchange (HFX) including
    B3LYP, PBE0 and MCY3
  * Dispersion corrections via DFT-D2 and DFT-D3 pair-potential models
  * Density-Fitting for DFT via Bloechl or Density Derived Atomic Point Charges
    (DDAPC) charges and for HFX via Auxiliary Density Matrix Methods (ADMM)
  * Sparse matrix and prescreening techniques for linear-scaling Kohn-Sham (KS)
    matrix computation
  * Orbital Transformation (OT) or Direct Inversion of the iterative subspace
    (DIIS) self-consistent field (SCF) minimizer
  * Excited states via time-dependent DFT (TDDFT)
 .
 Ab-initio Molecular Dynamics:
 .
  * Born-Oppenheimer Molecular Dynamics (BOMD) 
  * Ehrenfest Molecular Dynamics (EMD)
  * PS extrapolation of initial wavefunction
  * Time-reversible Always Stable Predictor-Corrector (ASPC) integrator
  * Approximate Car-Parinello like Langevin Born-Oppenheimer Molecular Dynamics
 .
 Mixed quantum-classical (QM/MM) simulations:
 .
  * Real-space multigrid approach for the evaluation of the Coulomb
    interactions between the QM and the MM part
  * Linear-scaling electrostatic coupling treating of periodic boundary
    conditions
 .
 Further Features include:
 .
  * Single-point energies, geometry optimizations and frequency calculations
  * Several nudged-elastic band (NEB) algorithms (B-NEB, IT-NEB, CI-NEB, D-NEB) 
    for minimum energy path (MEP) calculations
  * Semi-Empirical calculations including the AM1, RM1, PM3, MNDO, MNDO-d, PNNL
    and PM6 parametrizations and density-functional tight-binding (DFTB), with
    or without periodic boundary conditions
  * Classical Molecular Dynamics (MD) simulations in microcanonical ensemble
    (NVE) or canonical ensmble (NVT) with Nose-Hover and canonical sampling
    through velocity rescaling (CSVR) thermostats
  * Metadynamics including well-tempered Metadynamics for Free Energy
    calculations
  * Classical Force-Field (MM) simulations
  * Monte-Carlo (MC) KS-DFT simulations
  * HFX module for linear-scaling MD simulations using hybrid functionals
  * Static (e.g. spectra) and dynamical (e.g. diffusion) properties 
 .
 CP2K does not implement Car-Parinello Molecular Dynamics (CPMD).

Package: cp2k-data
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Ab Initio Molecular Dynamics (data files)
 CP2K is a program to perform simulations of solid state, liquid, molecular and
 biological systems. It is especially aimed at massively parallel and linear
 scaling electronic structure methods and state-of-the-art ab-inito molecular
 dynamics (AIMD) simulations.
 .
 This package contains basis sets, pseudo-potentials and force-field parameters.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/mpi-default-dev/debian_defaults

DEB_BUILD_ARCH=$(shell dpkg-architecture -qDEB_BUILD_ARCH)

ifeq ($(DEB_BUILD_ARCH), i386)
    export FFTW3_ALIGN=-D__FFTW3_UNALIGNED
else
    export FFTW3_ALIGN=
endif

export LIB_SCALAPACK=-lscalapack-$(ARCH_DEFAULT_MPI_IMPL)
export LIB_BLACS=-lblacsCinit-$(ARCH_DEFAULT_MPI_IMPL) -lblacs-$(ARCH_DEFAULT_MPI_IMPL)
export OMPI_MCA_plm_rsh_agent=/bin/false

PLATFORM=Linux
ARCH=`uname -m`
FORT_C_NAME=gfortran

%:
	dh $@ 

override_dh_auto_clean:
	(cd arch; ln -fs $(PLATFORM)-generic-$(FORT_C_NAME).popt $(PLATFORM)-$(ARCH)-$(FORT_C_NAME).popt)
	(cd makefiles; $(MAKE) ARCH=$(PLATFORM)-$(ARCH)-$(FORT_C_NAME) VERSION=popt distclean)
	(cd web/manual; rm -rf CP2K_INPUT; rm -f *.html *.xml)
	rm -f arch/$(PLATFORM)-$(ARCH)-$(FORT_C_NAME).*
	rm -rf LAST* TEST*
	dh_auto_clean

override_dh_auto_build:
	(cd arch; ln -fs $(PLATFORM)-generic-$(FORT_C_NAME).popt $(PLATFORM)-$(ARCH)-$(FORT_C_NAME).popt)
	(cd makefiles; $(MAKE) ARCH=$(PLATFORM)-$(ARCH)-$(FORT_C_NAME) VERSION=popt all)
	(cd web/manual; $(CURDIR)/exe/*/cp2k.popt --xml)
	(cd web/manual; saxonb-xslt -o index.html -ext:on cp2k_input.xml cp2k_input.xsl)
	(cd web/manual; saxonb-xslt -o index_javascript.html -ext:on cp2k_input.xml cp2k_input_javascript.xsl)

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	ln -nfs testresults LAST-$(PLATFORM)-$(ARCH)-$(FORT_C_NAME)-popt
	-(cd tools; ARCH=$(PLATFORM)-$(ARCH)-$(FORT_C_NAME) ./do_regtest -quick \
		-config ../debian/regtest.config                                \
		-restrictdir SE/regtest                                         \
		-restrictdir Fist/regtest                                       \
		-restrictdir NEB/regtest-1                                      \
		-restrictdir QS/regtest-gapw                                    \
		-restrictdir QS/regtest-gpw-1                                   \
		-restrictdir QS/regtest-hfx                                     \
		-restrictdir QS/regtest-nmr-1)
endif

=== debian/watch ===
# only follow the branches, so we know, when the next one is released

version=3
http://cp2k.svn.sourceforge.net/viewvc/cp2k/branches/ .*/cp2k-(\d+)_(\d+)-branch/$
